#include <stdio.h>
#include <stdlib.h>
#include <term.h>
#include <time.h>

#define A_POGRUBIONY (1 << 0)

#define KOLOR_CZARNY 0
#define KOLOR_CZERWONY 1
#define KOLOR_ZIELONY 2
#define KOLOR_BRAZOWY 3
#define KOLOR_NIEBIESKI 4
#define KOLOR_MAGENTA 5
#define KOLOR_CYJAN 6
#define KOLOR_BIALY 7

typedef struct {
  int attr;
  int kolor;
} atrybut;

static atrybut const bombki[] = {
  {A_POGRUBIONY, KOLOR_CZERWONY},
  {A_POGRUBIONY, KOLOR_NIEBIESKI},
  {A_POGRUBIONY, KOLOR_BRAZOWY},
  {A_POGRUBIONY, KOLOR_MAGENTA},
  {A_POGRUBIONY, KOLOR_CYJAN},
  {A_POGRUBIONY, KOLOR_BIALY},
};
static int const ile_b = sizeof bombki / sizeof *bombki;

static atrybut const choinka = {0, KOLOR_ZIELONY};
static atrybut const podstawa = {0, KOLOR_BRAZOWY};
static atrybut const podpis = {A_POGRUBIONY, KOLOR_CZERWONY};
static atrybut const gwiazdka = {A_POGRUBIONY, KOLOR_BRAZOWY};

static void inicjuj_rng()
{
  unsigned ziarno = 0;
  FILE* f = fopen("/dev/urandom", "rb");
  if (f != NULL) {
    unsigned nowe_ziarno;
    if (fread(&nowe_ziarno, sizeof nowe_ziarno, 1, f) == 1) {
      ziarno = nowe_ziarno;
    }
    fclose(f);
  }
  if (ziarno == 0) {
    ziarno = time(NULL);
  }
  srand(ziarno);
}

static char const rysunek[] =
"           *\n"
"          /.\\\n"
"         /..'\\\n"
"         /'.'\\\n"
"        /.''.'\\\n"
"        /.'.'.\\\n"
"       /'.''.'.\\\n"
"  jgs  ^^^[_]^^^\n"
;

static void ustaw(atrybut const* attr)
{
  static atrybut ostatni = {-1, -1};
  if (ostatni.attr == attr->attr && ostatni.kolor == attr->kolor) return;
  ostatni = *attr;
  putp(exit_attribute_mode);
  if ((attr->attr & A_POGRUBIONY) != 0) {
    putp(enter_bold_mode);
  }
  putp(tparm(set_a_foreground, attr->kolor));
}

int main()
{
  inicjuj_rng();
  setupterm(NULL, 1, NULL);
  atrybut const* kolor = &choinka;
  for (int i = 0; rysunek[i] != '\0'; i++) {
    char c = rysunek[i];
    if (c == '[') kolor = &podstawa;
    atrybut const* akt = kolor;
    if (c >= 'a' && c <= 'z') akt = &podpis;
    if (c == '.') akt = &bombki[rand() % ile_b];
    if (c == '*') akt = &gwiazdka;
    if (c == ']') kolor = &choinka;
    ustaw(akt);
    putchar(c);
  }
  putp(exit_attribute_mode);
  return 0;
}
